Introduction
==============

The Entity Framework needs to be decomposed into multiple layers that should be decoupled and should be usable in isolation.

I see three main components here:

 * Entity Model Engine
 * Entity Http API Server
 * Entity Client

## Entity Model Engine

The model engine should be a Node.js module that exposes a javascript API for creating and managing entity models.

## Entity Http API Server

The Http API server should use the model engine under the hood and should expose a public HTTP API to manage entity models and their instances.

## Entity Client

Should be a web-app that displays a nice UI and is connected to the Http API Server. It helps Entity Framework administrators manage entities without writing code.
