var alchemy = require('./alchemy')
var Insert  = require('alchemy/Insert')
var Select  = require('alchemy/Select')
var Column  = require('alchemy/Column')

var UUIDColumn = Column('uuid_generate_v4()')

function unref(obj){
    return JSON.parse(JSON.stringify(obj))
}

module.exports = function(meta){

    var name      = require('./config').metadataTableName
    var metaTable = require('./getMetaTable')()
    var IdColumn  = metaTable.c.id
    var JsonColumn  = metaTable.c.json

    var json = unref(meta)

    return Select(IdColumn, JsonColumn)
            .from(metaTable)
            .where(JsonColumn.jsonField('name'))
            .is(json.name)
            .end()
            .execute()
            .then(function(result){
                var record = result.rows[0]

                if (!record){
                    return Select(
                                UUIDColumn.as('id')
                            )
                            .execute()
                            .then(function(result){
                                var id = result.rows[0].id

                                json.id  = id

                                return {
                                    insert: metaTable
                                        .insert()
                                        .values({
                                            id  : id,
                                            json: JSON.stringify(json)
                                        }),
                                    id: id
                                }
                            })
                } else {
                    return {
                        id: record.id
                    }
                }
            })
}