var Promise = require('bluebird')
var Transaction = require('alchemy/Transaction')
var Drop = require('alchemy/Drop')

module.exports = function(metaTable, metaColumns, id){

    Select(metaColumns.json.jsonField('table'))
        .where(metaColumns.id).is(id)
        .execute(function(result){
            if (!result.rows[0]){
                throw new Error('No entity with id ' + id + '.')
            }

            return result.rows[0].table
        })
        .then(function(table){
            var DeleteFromMeta = metaTable.delete()
                                    .where('id').is(id).end()

            var DropTable = Drop().table(table)

            return Transaction(
                        DeleteFromMeta,
                        DropTable
                    ).execute()
        })
}