var Promise = require('bluebird')
var paginate = require('../helpers/paginate')
var selectBy = require('../helpers/selectBy')
var filterOnUser = require('../helpers/filterOnUser')

var STORE = {}

function cache(id){
    return function(json){
        STORE[id] = json
    }
}

function get(id){
    return STORE[id]
}

function isCached(id){
    return !!get(id)
}

module.exports = function(metaTable, metaColumns, id){

    if (isCached(id)){
        var json = get(id)
        log('Entity json server from cache for entity ' + json)
        return Promise.cast(json)
    }

    return selectBy('id', id)
            .execute()
            .then(function(result){
                var row = result.rows[0]

                if (!row){
                    throw new Error('No entity found with id ' + id + '.')
                }

                return row.json
            })
            .then(filterOnUser)
            .then(cache(id))
}