var Promise = require('bluebird')
var entityToJson = require('./entityToJson')
var getMetaTable = require('../../getMetaTable')

function response(res){

    return {
        rows : res.rows.map(entityToJson),
        count: res.rowCount
    }
}

function count(res){
    return res.rows[0].count
}

module.exports = function(select, config){

    var metaTable = getMetaTable()
    var IdColumn  = metaTable.c.id

    config = config || {}

    var SelectPromise = select.clone().limit(config.limit)
                .page(config.page)
                .execute()
                .then(response)

    var CountPromise = select
                        .clone()
                        .setColumns([IdColumn.count()])
                        .execute()
                        .then(count)

    return Promise.join(
                SelectPromise,
                CountPromise,
                function(result, totalCount){
                    result.totalCount = totalCount * 1
                    result.pages      = Math.ceil(totalCount/(config.limit || 1))
                    return result
                })
}