var CONFIG       = require('../config')
var Types        = require('alchemy/Types')
var defineEntity = require('../defineEntity')

var compare = require('../passwd/compare')

module.exports = defineEntity({
    name : 'User',
    table: 'users',

    properties: {
        email   : [Types.String(80), { unique : true }],
        username: [Types.String(80), { unique : true, notNull: true }],
        salt    : [Types.String(200)],
        password: [Types.String(1000)]
    },

    matchesPassword: function(pass){
        return compare(pass, this.values.password)
    }
})