var CONFIG  = require('../config')
var Promise = require('bluebird')
var fs      = Promise.promisifyAll(require('fs'))
var path    = require('path')

function initFiles(files, dir){

    dir = dir || __dirname

    return files.map(function(file){
        var order = file.substring(file.indexOf('.') + 1, file.lastIndexOf('.'))

        if (!isNaN(parseInt(order, 10))){
            return {
                order: order,
                file : path.join(dir, file)
            }
        }

    }).filter(function(a){
        return !!a
    }).sort(function(a, b){
        return a.order - b.order
    }).map(function(a){
        return a.file
    })
}

function sequence(){

    var dir = __dirname

    return fs.readdirAsync(dir)
            .then(function(files){

                var results = []

                return Promise.reduce(
                        initFiles(files, dir),
                        function(_, file, index){
                            log('Initting file ', file)
                            return require(file)().then(function(result){
                                log('Done initting ', file, '.')
                                results.push(result)
                            })
                        },
                        results
                    )
            })
}

module.exports = sequence