'use strict'

var bunyan = require('bunyan')
var loggers = {}

var appConfig = require('./config')

module.exports = function(name, location){

    name     = name || 'main'
    location = location || appConfig.logger[name]

    if (!loggers[name]){

        var logger = loggers[name] = bunyan.createLogger({
            name   : name,
            streams: [{ path: location }]
        })


        ;['info', 'debug', 'trace', 'warn', 'error', 'fatal'].forEach(function(name){
            logger[name] = logger[name].bind(logger)
        })
    }

    return loggers[name]
}