var Bcrypt  = require('bcrypt')
var Promise = require('bluebird')

var genSalt = Promise.promisify(Bcrypt.genSalt)
var hash    = Promise.promisify(Bcrypt.hash)

module.exports = function(password){

    return genSalt(10).then(function(salt){
        return hash(password, salt)
                .then(function(hash){
                    return {
                        hash: hash,
                        salt: salt
                    }
                })
    })
}
