describe('EntityBase', function(){

    var defineEntity = require('../defineEntity')

    var Person = defineEntity({
        properties: {
            'id': [{type: 'integer'}],
            'firstName': [{type: 'string'}],
            'lastName': [{type: 'string'}]
        }
    })

    it('should handle values correctly', function(){

        var john = new Person({
            firstName: 'john',
            lastName : 'billson'
        })

        john
            .values
            .firstName
                .should
                .equal('john')


        john.set({
            firstName: 'bill'
        })

        john.values.firstName
            .should
            .equal('bill')

    })

    it('should properly set property by setter', function(){

        var john = new Person({
            firstName: 'john',
            lastName: 'billson'
        })

        john.values.firstName = 'billy'

        john.values.firstName
            .should
            .equal('billy')

        john.values.firstName
            .should
            .equal('billy')
    })

    it('should propertly clone', function(){

        var john = new Person({
            firstName: 'john',
            lastName: 'billson'
        })

        var john1 = john.clone()

        john.values.firstName
            .should
            .equal(john1.values.firstName)
    })

    it('should return fine from toJSON', function(){

        var john = new Person({
            firstName: 'john',
            lastName: 'billson'
        }).clone()

        var json = john.toJSON()

        json.firstName
            .should
            .equal('john')


        john.values.lastName = 'xxx'
        john.toJSON().lastName
            .should
            .equal('xxx')
    })

})